## primecount 7.14+ds

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.4...3.27)
project(primecount CXX)
set(PRIMECOUNT_VERSION_MAJOR 7)
set(PRIMECOUNT_VERSION_MINOR 14)
set(PRIMECOUNT_VERSION "${PRIMECOUNT_VERSION_MAJOR}.${PRIMECOUNT_VERSION_MINOR}")

# Build options ######################################################

option(BUILD_PRIMECOUNT    "Build the primecount binary"           ON)
option(BUILD_LIBPRIMESIEVE "Build libprimesieve"                   ON)
option(BUILD_SHARED_LIBS   "Build the shared libprimecount"        OFF)
option(BUILD_STATIC_LIBS   "Build the static libprimecount"        ON)
option(BUILD_MANPAGE       "Regenerate man page using a2x program" OFF)
option(BUILD_TESTS         "Build the test programs"               OFF)

option(WITH_OPENMP          "Enable OpenMP multi-threading"        ON)
option(WITH_MULTIARCH       "Enable runtime dispatching to fastest supported CPU instruction set" ON)
option(WITH_DIV32           "Use 32-bit division instead of 64-bit division whenever possible" OFF)
option(WITH_MSVC_CRT_STATIC "Link primecount.lib with /MT instead of the default /MD" OFF)
option(WITH_FLOAT128        "Use __float128 (requires libquadmath), increases precision of Li(x) & RiemannR" OFF)
option(WITH_JEMALLOC        "Use jemalloc allocator"               OFF)

# Enable/Disable libdivide ###########################################

# Historically, integer division has been one of the slowest
# instructions on most CPU architectures. Hence by default we
# enable libdivide which replaces expensive integer division
# instructions by a sequence of shift, add and multiply
# instructions which is often much faster.

set(DEFAULT_LIBDIVIDE ON)

# Apple Silicon CPUs first released in 2020 have very fast integer
# division instructions. For Apple Silicon CPUs on Apple OSes
# we disable libdivide to get the best performance.

if(APPLE)
    include("${PROJECT_SOURCE_DIR}/cmake/Apple_ARM64.cmake")
    if(Apple_ARM64)
        set(DEFAULT_LIBDIVIDE OFF)
    endif()
endif()

option(WITH_LIBDIVIDE "Use libdivide.h" ${DEFAULT_LIBDIVIDE})

# Option sanity checks ###############################################

# We don't yet support building libprimecount as a shared DLL
# library on Windows. If you need this let me know...
if(WIN32)
    set(BUILD_SHARED_LIBS OFF)
endif()

if(NOT BUILD_SHARED_LIBS AND NOT BUILD_STATIC_LIBS)
    message(FATAL_ERROR "One or both of BUILD_SHARED_LIBS or BUILD_STATIC_LIBS must be set to ON!")
endif()

# Static vs. shared linking ##########################################

# By default libprimecount is linked statically if only the static
# libprimecount has been built. If libprimecount has been built as
# both a static and shared library then the shared libprimecount will
# be used for linking.

# It is possible to force static linking by setting:
# cmake -DSTATICALLY_LINK_LIBPRIMECOUNT=ON
# This way libprimecount will be linked statically even if
# libprimecount has been built as both a static and shared library.

if(NOT STATICALLY_LINK_LIBPRIMECOUNT)
    if(BUILD_STATIC_LIBS AND NOT BUILD_SHARED_LIBS)
        set(STATICALLY_LINK_LIBPRIMECOUNT TRUE)
    endif()
endif()

if(STATICALLY_LINK_LIBPRIMECOUNT AND NOT BUILD_STATIC_LIBS)
    message(FATAL_ERROR "Using STATICALLY_LINK_LIBPRIMECOUNT=ON requires BUILD_STATIC_LIBS=ON!")
endif()

# Set default build type to Release ##################################

if(NOT CMAKE_VERSION VERSION_LESS 3.9)
    get_property(isMultiConfig GLOBAL PROPERTY GENERATOR_IS_MULTI_CONFIG)
elseif(CMAKE_CONFIGURATION_TYPES)
    set(isMultiConfig TRUE)
endif()

if(NOT isMultiConfig AND NOT CMAKE_BUILD_TYPE)
    set(CMAKE_BUILD_TYPE Release CACHE STRING
    "Choose the type of build, options are: None Debug Release RelWithDebInfo MinSizeRel." FORCE)
endif()

if(CMAKE_BUILD_TYPE STREQUAL "Debug")
    list(APPEND PRIMECOUNT_COMPILE_DEFINITIONS "ENABLE_ASSERT")
endif()

# primecount binary source files #####################################

set(BIN_SRC src/app/CmdOptions.cpp
            src/app/main.cpp
            src/app/help.cpp
            src/app/test.cpp)

# primecount library source files ####################################

set(LIB_SRC src/api.cpp
            src/api_c.cpp
            src/BitSieve240.cpp
            src/FactorTable.cpp
            src/RiemannR.cpp
            src/P2.cpp
            src/P3.cpp
            src/PhiTiny.cpp
            src/PiTable.cpp
            src/S1.cpp
            src/Sieve.cpp
            src/LoadBalancerP2.cpp
            src/LoadBalancerS2.cpp
            src/LogarithmicIntegral.cpp
            src/StatusS2.cpp
            src/generate_primes.cpp
            src/nth_prime.cpp
            src/phi.cpp
            src/phi_vector.cpp
            src/pi_legendre.cpp
            src/pi_lehmer.cpp
            src/pi_meissel.cpp
            src/pi_primesieve.cpp
            src/print.cpp
            src/util.cpp
            src/lmo/pi_lmo1.cpp
            src/lmo/pi_lmo2.cpp
            src/lmo/pi_lmo3.cpp
            src/lmo/pi_lmo4.cpp
            src/lmo/pi_lmo5.cpp
            src/lmo/pi_lmo_parallel.cpp
            src/deleglise-rivat/S2_hard.cpp
            src/deleglise-rivat/S2_trivial.cpp
            src/deleglise-rivat/pi_deleglise_rivat.cpp
            src/gourdon/pi_gourdon.cpp
            src/gourdon/Phi0.cpp
            src/gourdon/B.cpp
            src/gourdon/D.cpp
            src/gourdon/LoadBalancerAC.cpp
            src/gourdon/SegmentedPiTable.cpp
            src/gourdon/Sigma.cpp)

# Use libdivide.h (fast integer divison) #############################

if(WITH_LIBDIVIDE)
    set(LIB_SRC ${LIB_SRC} src/deleglise-rivat/S2_easy_libdivide.cpp)
    set(LIB_SRC ${LIB_SRC} src/gourdon/AC_libdivide.cpp)
else()
    set(LIB_SRC ${LIB_SRC} src/deleglise-rivat/S2_easy.cpp)
    set(LIB_SRC ${LIB_SRC} src/gourdon/AC.cpp)
endif()

# Check if compiler supports CPU multiarch ###########################

if(WITH_MULTIARCH)
    include("${PROJECT_SOURCE_DIR}/cmake/multiarch_x86_popcnt.cmake")
    include("${PROJECT_SOURCE_DIR}/cmake/multiarch_avx512_vpopcnt.cmake")

    if(multiarch_x86_popcnt OR multiarch_avx512_vpopcnt)
        set(LIB_SRC ${LIB_SRC} src/x86/cpuid.cpp)
    endif()

    if(NOT multiarch_avx512_vpopcnt)
        include("${PROJECT_SOURCE_DIR}/cmake/multiarch_arm_sve.cmake")
    endif()
endif()

# Enable __float128 support (requires libquadmath) ###################

if(WITH_FLOAT128)
    list(APPEND PRIMECOUNT_LINK_LIBRARIES "quadmath")
    list(APPEND PRIMECOUNT_COMPILE_DEFINITIONS "HAVE_FLOAT128")
endif()

# Use 32-bit integer division ########################################

# Check at runtime if the dividend and divisor are < 2^32 and
# if so use 32-bit integer division instead of 64-bit integer
# division. On most CPUs before 2020 this significantly
# improves performance.
if(WITH_DIV32)
    list(APPEND PRIMECOUNT_COMPILE_DEFINITIONS "ENABLE_DIV32")
endif()

# Use -Wno-uninitialized with GCC compiler ###########################

# GCC's -Wuninitialized enabled with -Wall -pedantic causes
# false postive warnings in libprimecount:
# https://gcc.gnu.org/bugzilla/show_bug.cgi?id=107287
if(CMAKE_CXX_COMPILER_ID STREQUAL "GNU")
    set(WNO_UNINITIALIZED "-Wno-uninitialized")
endif()

# Check if compiler supports C++11 or later ##########################

include("${PROJECT_SOURCE_DIR}/cmake/compiler_supports_cpp11.cmake")

# Check if int128_t is supported #####################################

include("${PROJECT_SOURCE_DIR}/cmake/int128_t.cmake")

# Check for OpenMP ###################################################

if(WITH_OPENMP)
    include("${PROJECT_SOURCE_DIR}/cmake/OpenMP.cmake")
endif()

# Required includes ##################################################

include(GNUInstallDirs)

# libprimesieve ######################################################

# By default the libprimesieve dependency is built from source
# (BUILD_LIBPRIMESIEVE=ON). However when packaging primecount
# for e.g. a Linux distro this is not a good idea. For this use
# case it is better to install the libprimesieve package
# (e.g. libprimesieve-dev) and link against that version.

if(BUILD_LIBPRIMESIEVE)
    set(COPY_BUILD_EXAMPLES "${BUILD_EXAMPLES}")
    set(COPY_BUILD_MANPAGE "${BUILD_MANPAGE}")
    set(COPY_BUILD_TESTS "${BUILD_TESTS}")

    set(BUILD_EXAMPLES OFF CACHE BOOL "Build example programs" FORCE)
    set(BUILD_MANPAGE OFF CACHE BOOL "Build primesieve manpage" FORCE)
    set(BUILD_TESTS OFF CACHE BOOL "Build primesieve tests" FORCE)
    option(BUILD_PRIMESIEVE "Build primesieve binary" OFF)

    add_subdirectory(lib/primesieve)

    set(BUILD_EXAMPLES "${COPY_BUILD_EXAMPLES}" CACHE BOOL "Build example programs" FORCE)
    set(BUILD_MANPAGE "${COPY_BUILD_MANPAGE}" CACHE BOOL "Regenerate man page using a2x" FORCE)
    set(BUILD_TESTS "${COPY_BUILD_TESTS}" CACHE BOOL "Build test programs" FORCE)
else()
    find_package(primesieve REQUIRED)

    if(primesieve_VERSION VERSION_LESS 11.0)
        message(FATAL_ERROR "Found libprimesive-${primesieve_VERSION}, but primecount requires libprimesive >= 11.0")
    endif()
endif()

# libprimecount ######################################################

if(BUILD_SHARED_LIBS)
    add_library(libprimecount SHARED ${LIB_SRC})
    set_target_properties(libprimecount PROPERTIES OUTPUT_NAME primecount)
    set_target_properties(libprimecount PROPERTIES SOVERSION ${PRIMECOUNT_VERSION_MAJOR})
    set_target_properties(libprimecount PROPERTIES VERSION ${PRIMECOUNT_VERSION})
    target_compile_options(libprimecount PRIVATE "${WNO_UNINITIALIZED}")
    target_compile_definitions(libprimecount PRIVATE ${PRIMECOUNT_COMPILE_DEFINITIONS})
    target_link_libraries(libprimecount PRIVATE primesieve::primesieve ${PRIMECOUNT_LINK_LIBRARIES})

    target_compile_features(libprimecount
    PRIVATE
        cxx_constexpr
        cxx_lambdas
        cxx_range_for)

    target_include_directories(libprimecount PUBLIC
        $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
        $<INSTALL_INTERFACE:include>)

    install(TARGETS libprimecount
            RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
            LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
            ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR})
endif()

# libprimecount-static ###############################################

if(BUILD_STATIC_LIBS)
    add_library(libprimecount-static STATIC ${LIB_SRC})
    set_target_properties(libprimecount-static PROPERTIES OUTPUT_NAME primecount)
    target_compile_options(libprimecount-static PRIVATE "${WNO_UNINITIALIZED}")
    target_compile_definitions(libprimecount-static PRIVATE ${PRIMECOUNT_COMPILE_DEFINITIONS})
    target_link_libraries(libprimecount-static PRIVATE primesieve::primesieve ${PRIMECOUNT_LINK_LIBRARIES})

    if(WITH_MSVC_CRT_STATIC)
        set_target_properties(libprimecount-static PROPERTIES MSVC_RUNTIME_LIBRARY "MultiThreaded")
    endif()

    target_compile_features(libprimecount-static
    PRIVATE
        cxx_constexpr
        cxx_lambdas
        cxx_range_for)

    target_include_directories(libprimecount-static PUBLIC
        $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
        $<INSTALL_INTERFACE:include>)

    install(TARGETS libprimecount-static
            RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
            LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
            ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR})
endif()

# Shared vs. static linking ##########################################

if(STATICALLY_LINK_LIBPRIMECOUNT)
    add_library(primecount::primecount ALIAS libprimecount-static)
else()
    add_library(primecount::primecount ALIAS libprimecount)
endif()

# primecount binary ##################################################

if(BUILD_PRIMECOUNT)
    add_executable(primecount ${BIN_SRC})
    target_link_libraries(primecount PRIVATE primecount::primecount primesieve::primesieve)
    target_compile_definitions(primecount PRIVATE ${PRIMECOUNT_COMPILE_DEFINITIONS})
    target_compile_features(primecount PRIVATE cxx_auto_type)

=== debian/changelog ===
primecount (7.14+ds-1) unstable; urgency=medium

  * New upstream minor release.

 -- Jerome Benoit <calculus@rezozer.net>  Mon, 02 Sep 2024 16:58:16 +0000

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS=hardening=+all

## inspired from mpfr material
ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
	CFLAGS    += -O0
	CXXCFLAGS += -O0
else ifeq ($(DEB_HOST_ARCH),alpha)
	CFLAGS   += -mieee
	CXXFLAGS += -mieee
else ifeq ($(DEB_HOST_ARCH),sha4)
	CFLAGS   += -mieee
	CXXFLAGS += -mieee
else
	CFLAGS   := $(subst -O2,-O3,$(CFLAGS))
	CXXFLAGS := $(subst -O2,-O3,$(CXXFLAGS))
endif

default:
	@uscan --no-conf --dehs --report || true

%:
	dh $@ --builddirectory=_BUILD

override_dh_auto_configure:
	dh_auto_configure -- \
		-DWITH_POPCNT=OFF \
		-DBUILD_LIBPRIMESIEVE=OFF \
		-DBUILD_SHARED_LIBS=ON \
		-DBUILD_STATIC_LIBS=ON \
		-DBUILD_TESTS=ON \
		-DBUILD_MANPAGE=ON

override_dh_auto_build-indep: README.toc.md
	$(MAKE) -f debian/adhoc/Makefile doc

override_dh_auto_test-indep:
	true

override_dh_auto_install-indep:
	DESTDIR=$(CURDIR)/debian/tmp $(CMAKE) \
			-DCMAKE_INSTALL_COMPONENT=libprimecount-headers \
		-P _BUILD/cmake_install.cmake

override_dh_prep-arch: README.toc.md

override_dh_installdocs:
	dh_installdocs -pprimecount-bin    --link-doc=libprimecount7
	dh_installdocs -plibprimecount-dev --doc-main-package=libprimecount-dev-common
	dh_installdocs --remaining-packages

override_dh_compress-indep:
	dh_compress -X.pdf -X.md -Xexamples

override_dh_missing:
	dh_missing --list-missing

README.toc.md:
	sed \
			-e '/\[libprimecount/d' \
			-e '/\[primecount-backup/d' \
			-e '/\[BUILD/d' \
			-e '/\[RELEASE/d' \
		doc/README.md > README.toc.md

CMAKE ?= cmake

## primecount 7.15+ds

=== debian/changelog ===
primecount (7.15+ds-1) unstable; urgency=medium

  * New upstream minor release.
  * Debianization:
    - d/{copyright,adhoc/{c,cpp}/Makefile, copyright year-tuples, refrech;
    - d/control:
      - Standards-Version, bump to 4.7.2 (no change).

 -- Jerome Benoit <calculus@rezozer.net>  Sun, 09 Mar 2025 15:23:48 +0000

## primecount 7.16%2Bds

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,7 +1,7 @@
 cmake_minimum_required(VERSION 3.4...3.27)
 project(primecount CXX)
 set(PRIMECOUNT_VERSION_MAJOR 7)
-set(PRIMECOUNT_VERSION_MINOR 14)
+set(PRIMECOUNT_VERSION_MINOR 16)
 set(PRIMECOUNT_VERSION "${PRIMECOUNT_VERSION_MAJOR}.${PRIMECOUNT_VERSION_MINOR}")
 
 # Build options ######################################################
@@ -162,11 +162,18 @@
     include("${PROJECT_SOURCE_DIR}/cmake/multiarch_avx512_vpopcnt.cmake")
 
     if(multiarch_x86_popcnt OR multiarch_avx512_vpopcnt)
-        set(LIB_SRC ${LIB_SRC} src/x86/cpuid.cpp)
-    endif()
-
-    if(NOT multiarch_avx512_vpopcnt)
+        set(LIB_SRC ${LIB_SRC} src/arch/x86/cpuid.cpp)
+        if (multiarch_avx512_vpopcnt)
+            set(LIB_SRC ${LIB_SRC} src/deleglise-rivat/S2_hard_multiarch_avx512.cpp)
+            set(LIB_SRC ${LIB_SRC} src/gourdon/D_multiarch_avx512.cpp)
+        endif()
+    else()
         include("${PROJECT_SOURCE_DIR}/cmake/multiarch_arm_sve.cmake")
+        if(multiarch_arm_sve)
+            set(LIB_SRC ${LIB_SRC} src/arch/arm/sve.cpp)
+            set(LIB_SRC ${LIB_SRC} src/deleglise-rivat/S2_hard_multiarch_arm_sve.cpp)
+            set(LIB_SRC ${LIB_SRC} src/gourdon/D_multiarch_arm_sve.cpp)
+        endif()
     endif()
 endif()
 
@@ -306,13 +313,3 @@
 if(STATICALLY_LINK_LIBPRIMECOUNT)
     add_library(primecount::primecount ALIAS libprimecount-static)
 else()
-    add_library(primecount::primecount ALIAS libprimecount)
-endif()
-
-# primecount binary ##################################################
-
-if(BUILD_PRIMECOUNT)
-    add_executable(primecount ${BIN_SRC})
-    target_link_libraries(primecount PRIVATE primecount::primecount primesieve::primesieve)
-    target_compile_definitions(primecount PRIVATE ${PRIMECOUNT_COMPILE_DEFINITIONS})
-    target_compile_features(primecount PRIVATE cxx_auto_type)

=== test/api/CMakeLists.txt ===
enable_language(C)
file(GLOB files "*.cpp" "*.c")

foreach(file ${files})
    get_filename_component(binary_name ${file} NAME_WE)
    add_executable(${binary_name} ${file})
    target_compile_definitions(${binary_name} PRIVATE ${PRIMECOUNT_COMPILE_DEFINITIONS})
    target_link_libraries(${binary_name} primecount::primecount primesieve::primesieve ${PRIMECOUNT_LINK_LIBRARIES})
    add_test(NAME ${binary_name} COMMAND ${binary_name})
endforeach()

## primecount 7.16+ds

=== test/CMakeLists.txt ===
file(GLOB files "*.cpp")

foreach(file ${files})
    get_filename_component(binary_name ${file} NAME_WE)
    add_executable(${binary_name} ${file})
    target_compile_definitions(${binary_name} PRIVATE ${PRIMECOUNT_COMPILE_DEFINITIONS})
    target_link_libraries(${binary_name} primecount::primecount primesieve::primesieve ${PRIMECOUNT_LINK_LIBRARIES})
    add_test(NAME ${binary_name} COMMAND ${binary_name})
endforeach()

# The order here is important, we want simpler implementations
# to be tested before more advanced/complex implementations.
# LMO is less complex than deleglise-rivat, deleglise-rivat is
# less complex than gourdon, and the C/C++ API depends on all
# these implementations.
add_subdirectory(lmo)
add_subdirectory(deleglise-rivat)
add_subdirectory(gourdon)
add_subdirectory(api)

=== test/deleglise-rivat/CMakeLists.txt ===
file(GLOB files "*.cpp")

foreach(file ${files})
    get_filename_component(binary_name ${file} NAME_WE)
    add_executable(${binary_name} ${file})
    target_compile_definitions(${binary_name} PRIVATE ${PRIMECOUNT_COMPILE_DEFINITIONS})
    target_link_libraries(${binary_name} primecount::primecount primesieve::primesieve ${PRIMECOUNT_LINK_LIBRARIES})
    add_test(NAME ${binary_name} COMMAND ${binary_name})
endforeach()

=== debian/changelog ===
primecount (7.16+ds-1) unstable; urgency=medium

  * New upstream minor release.

 -- Jerome Benoit <calculus@rezozer.net>  Sun, 06 Apr 2025 17:16:53 +0000

=== debian/watch ===
version=4
opts=repack,repacksuffix=+ds,compression=xz,dversionmangle=s/\+ds//,uversionmangle=s/-rc/~rc/,filenamemangle=s/.+\/v?(\d\S*)\.tar\.gz/primecount-$1\.tar\.gz/ \
https://github.com/kimwalisch/primecount/tags .*/archive/refs/tags/v?(\d\S*)\.tar\.gz

## primecount 7.19%2Bds

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,7 +1,7 @@
 cmake_minimum_required(VERSION 3.4...3.27)
 project(primecount CXX)
 set(PRIMECOUNT_VERSION_MAJOR 7)
-set(PRIMECOUNT_VERSION_MINOR 16)
+set(PRIMECOUNT_VERSION_MINOR 19)
 set(PRIMECOUNT_VERSION "${PRIMECOUNT_VERSION_MAJOR}.${PRIMECOUNT_VERSION_MINOR}")
 
 # Build options ######################################################
@@ -53,28 +53,6 @@
 
 if(NOT BUILD_SHARED_LIBS AND NOT BUILD_STATIC_LIBS)
     message(FATAL_ERROR "One or both of BUILD_SHARED_LIBS or BUILD_STATIC_LIBS must be set to ON!")
-endif()
-
-# Static vs. shared linking ##########################################
-
-# By default libprimecount is linked statically if only the static
-# libprimecount has been built. If libprimecount has been built as
-# both a static and shared library then the shared libprimecount will
-# be used for linking.
-
-# It is possible to force static linking by setting:
-# cmake -DSTATICALLY_LINK_LIBPRIMECOUNT=ON
-# This way libprimecount will be linked statically even if
-# libprimecount has been built as both a static and shared library.
-
-if(NOT STATICALLY_LINK_LIBPRIMECOUNT)
-    if(BUILD_STATIC_LIBS AND NOT BUILD_SHARED_LIBS)
-        set(STATICALLY_LINK_LIBPRIMECOUNT TRUE)
-    endif()
-endif()
-
-if(STATICALLY_LINK_LIBPRIMECOUNT AND NOT BUILD_STATIC_LIBS)
-    message(FATAL_ERROR "Using STATICALLY_LINK_LIBPRIMECOUNT=ON requires BUILD_STATIC_LIBS=ON!")
 endif()
 
 # Set default build type to Release ##################################
@@ -220,6 +198,7 @@
 # Required includes ##################################################
 
 include(GNUInstallDirs)
+include(CMakePackageConfigHelpers)
 
 # libprimesieve ######################################################
 
@@ -269,11 +248,15 @@
         cxx_lambdas
         cxx_range_for)
 
-    target_include_directories(libprimecount PUBLIC
+    target_include_directories(libprimecount
+    PUBLIC
         $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
-        $<INSTALL_INTERFACE:include>)
+        $<INSTALL_INTERFACE:include>
+    PRIVATE
+        ${CMAKE_CURRENT_SOURCE_DIR}/src)
 
     install(TARGETS libprimecount
+            EXPORT primecountShared
             RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
             LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
             ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR})
@@ -298,11 +281,15 @@
         cxx_lambdas
         cxx_range_for)
 
-    target_include_directories(libprimecount-static PUBLIC
+    target_include_directories(libprimecount-static
+    PUBLIC
         $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
-        $<INSTALL_INTERFACE:include>)
+        $<INSTALL_INTERFACE:include>
+    PRIVATE
+        ${CMAKE_CURRENT_SOURCE_DIR}/src)
 
     install(TARGETS libprimecount-static
+            EXPORT primecountStatic
             RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
             LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
             ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR})
@@ -310,6 +297,22 @@
 
 # Shared vs. static linking ##########################################
 
+# On Unix-like OSes we use shared linking against libprimecount by
+# default mainly because this is required by Linux distributions.
+# On Windows we use static linking by default because the library's
+# path is not encoded into the binary. This means that the binary
+# will only work if the DLL is in the same directory or a directory
+# that is in the PATH environment variable.
+
+if(WIN32 AND TARGET libprimecount-static)
+    set(STATICALLY_LINK_LIBPRIMECOUNT ON)
+elseif(NOT TARGET libprimecount)
+    set(STATICALLY_LINK_LIBPRIMECOUNT ON)
+endif()
+
 if(STATICALLY_LINK_LIBPRIMECOUNT)
     add_library(primecount::primecount ALIAS libprimecount-static)
 else()
+    add_library(primecount::primecount ALIAS libprimecount)
+endif()
+

=== test/api/CMakeLists.txt ===
--- 
+++ 
@@ -6,5 +6,13 @@
     add_executable(${binary_name} ${file})
     target_compile_definitions(${binary_name} PRIVATE ${PRIMECOUNT_COMPILE_DEFINITIONS})
     target_link_libraries(${binary_name} primecount::primecount primesieve::primesieve ${PRIMECOUNT_LINK_LIBRARIES})
+
+    target_include_directories(${binary_name}
+    PRIVATE
+        ${CMAKE_SOURCE_DIR}/src
+        ${CMAKE_SOURCE_DIR}/src/deleglise-rivat
+        ${CMAKE_SOURCE_DIR}/src/gourdon
+        ${CMAKE_SOURCE_DIR}/src/lmo)
+
     add_test(NAME ${binary_name} COMMAND ${binary_name})
 endforeach()

=== debian/tests/control ===
Test-Command: primecount --test

Tests: make-check-bin
Depends: primecount-bin

Tests: build-examples
Depends: primecount-doc, libprimecount-dev, build-essential, pkgconf

Tests: make-check-dev
Depends: libprimecount-dev, build-essential, pkgconf
Restrictions: allow-stderr

## primecount 7.19+ds

=== test/CMakeLists.txt ===
--- 
+++ 
@@ -5,6 +5,14 @@
     add_executable(${binary_name} ${file})
     target_compile_definitions(${binary_name} PRIVATE ${PRIMECOUNT_COMPILE_DEFINITIONS})
     target_link_libraries(${binary_name} primecount::primecount primesieve::primesieve ${PRIMECOUNT_LINK_LIBRARIES})
+
+    target_include_directories(${binary_name}
+    PRIVATE
+        ${CMAKE_SOURCE_DIR}/src
+        ${CMAKE_SOURCE_DIR}/src/deleglise-rivat
+        ${CMAKE_SOURCE_DIR}/src/gourdon
+        ${CMAKE_SOURCE_DIR}/src/lmo)
+
     add_test(NAME ${binary_name} COMMAND ${binary_name})
 endforeach()

=== test/deleglise-rivat/CMakeLists.txt ===
--- 
+++ 
@@ -5,5 +5,13 @@
     add_executable(${binary_name} ${file})
     target_compile_definitions(${binary_name} PRIVATE ${PRIMECOUNT_COMPILE_DEFINITIONS})
     target_link_libraries(${binary_name} primecount::primecount primesieve::primesieve ${PRIMECOUNT_LINK_LIBRARIES})
+ 
+    target_include_directories(${binary_name}
+    PRIVATE
+        ${CMAKE_SOURCE_DIR}/src
+        ${CMAKE_SOURCE_DIR}/src/deleglise-rivat
+        ${CMAKE_SOURCE_DIR}/src/gourdon
+        ${CMAKE_SOURCE_DIR}/src/lmo)
+
     add_test(NAME ${binary_name} COMMAND ${binary_name})
 endforeach()

=== debian/changelog ===
primecount (7.19+ds-2) unstable; urgency=medium

  * Upload to unstable.

 -- Jerome Benoit <calculus@rezozer.net>  Sun, 17 Aug 2025 15:44:52 +0000

primecount (7.19+ds-1) experimental; urgency=medium

  * New upstream minor release.
  * Debianization:
    - d/tests/*:
      - d/t/make-check-dev, refresh.

 -- Jerome Benoit <calculus@rezozer.net>  Sat, 07 Jun 2025 23:43:16 +0000

primecount (7.18+ds-1) experimental; urgency=medium

  * New upstream minor release.
  * Debianization:
    - d/tests/*:
      - d/t/control, reorder tests;
      - d/t/make-check-dev, refresh and harden.

 -- Jerome Benoit <calculus@rezozer.net>  Sun, 18 May 2025 15:16:43 +0000

primecount (7.17+ds-1) experimental; urgency=medium

  * New upstream minor release.

 -- Jerome Benoit <calculus@rezozer.net>  Sat, 10 May 2025 17:40:43 +0000

=== debian/control ===
Source: primecount
Maintainer: Debian Math Team <team+math@tracker.debian.org>
Uploaders: Jerome Benoit <calculus@rezozer.net>
Section: math
Priority: optional
Rules-Requires-Root: no
Build-Depends:
 debhelper-compat (=13),
 cmake,
 libprimesieve-dev (>=8.0),
 asciidoc-base, xmlto
Build-Depends-Indep:
	pandoc
Standards-Version: 4.7.2
Vcs-Git: https://salsa.debian.org/math-team/primecount.git
Vcs-Browser: https://salsa.debian.org/math-team/primecount
Homepage: https://github.com/kimwalisch/primecount

Package: primecount
Architecture: all
Multi-Arch: foreign
Depends: primecount-bin, ${misc:Depends}
Description: fast prime number counter C/C++ library
 primecount is a free software program and C/C++ library that counts
 the primes below an integer x <= 10^31 using highly optimized
 implementations of the combinatorial prime counting algorithms.
 .
 See https://github.com/kimwalisch/primecount for more information.
 .
 This dummy package provides the standard installation.

Package: libprimecount7
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: primecount-bin (= ${binary:Version})
Pre-Depends: ${misc:Pre-Depends}
Conflicts: libprimecount
Provides: libprimecount
Description: fast prime number counter C/C++ library -- lib
 primecount is a free software program and C/C++ library that counts
 the primes below an integer x <= 10^31 using highly optimized
 implementations of the combinatorial prime counting algorithms.
 .
 See https://github.com/kimwalisch/primecount for more information.
 .
 This package provides the shared library.

Package: libprimecount-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends:
 libprimecount7 (= ${binary:Version}), libprimecount-dev-common (= ${source:Version}),
 libprimesieve-dev,
 ${misc:Depends}
Suggests: primecount-doc (= ${source:Version}), pkgconf
Conflicts: libprimecount-dev
Provides: libprimecount-dev
Description: fast prime number counter C/C++ library -- libdev
 primecount is a free software program and C/C++ library that counts
 the primes below an integer x <= 10^31 using highly optimized
 implementations of the combinatorial prime counting algorithms.
 .
 See https://github.com/kimwalisch/primecount for more information.
 .
 This package provides the static library and symbolic links needed
 for development.

Package: libprimecount-dev-common
Architecture: all
Multi-Arch: foreign
Replaces: libprimecount7-dev-common
Breaks: libprimecount7-dev-common
Section: libdevel
Depends: ${misc:Depends}
Recommends: libprimecount-dev (= ${binary:Version})
Provides: libprimecount-dev-common
Description: fast prime number counter C/C++ library -- headers
 primecount is a free software program and C/C++ library that counts
 the primes below an integer x <= 10^31 using highly optimized
 implementations of the combinatorial prime counting algorithms.
 .
 See https://github.com/kimwalisch/primecount for more information.
 .
 This package provides the headers needed by developers.

Package: primecount-bin
Architecture: any
Multi-Arch: foreign
Depends: ${shlibs:Depends}, ${misc:Depends}
Suggests: primecount-doc (= ${source:Version})
Description: fast prime number counter C/C++ library -- bin
 primecount is a free software program and C/C++ library that counts
 the primes below an integer x <= 10^31 using highly optimized
 implementations of the combinatorial prime counting algorithms.
 .
 This package provides the command line utility primecount.

Package: primecount-doc
Architecture: all
Multi-Arch: foreign
Section: doc
Depends: ${misc:Depends}
Suggests: www-browser
Enhances: primecount-bin (= ${binary:Version}), libprimecount-dev (= ${binary:Version})
Description: fast prime number counter C/C++ library -- doc
 primecount is a free software program and C/C++ library that counts
 the primes below an integer x <= 10^31 using highly optimized
 implementations of the combinatorial prime counting algorithms.
 .
 See https://github.com/kimwalisch/primecount for more information.
 .
 This package provides the API documentation with its concomitant examples.

## primecount 7.20+ds

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,7 +1,7 @@
 cmake_minimum_required(VERSION 3.4...3.27)
 project(primecount CXX)
 set(PRIMECOUNT_VERSION_MAJOR 7)
-set(PRIMECOUNT_VERSION_MINOR 19)
+set(PRIMECOUNT_VERSION_MINOR 20)
 set(PRIMECOUNT_VERSION "${PRIMECOUNT_VERSION_MAJOR}.${PRIMECOUNT_VERSION_MINOR}")
 
 # Build options ######################################################
@@ -46,8 +46,11 @@
 # Option sanity checks ###############################################
 
 # We don't yet support building libprimecount as a shared DLL
-# library on Windows. If you need this let me know...
-if(WIN32)
+# library on Windows using the MSVC compiler. The MSVC compiler
+# by default does not allow accessing global variables that
+# are inside a DLL, unless all those variables are annotated
+# using __declspec(dllexport) and __declspec(dllimport).
+if(WIN32 AND NOT MINGW)
     set(BUILD_SHARED_LIBS OFF)
 endif()
 
@@ -310,9 +313,3 @@
     set(STATICALLY_LINK_LIBPRIMECOUNT ON)
 endif()
 
-if(STATICALLY_LINK_LIBPRIMECOUNT)
-    add_library(primecount::primecount ALIAS libprimecount-static)
-else()
-    add_library(primecount::primecount ALIAS libprimecount)
-endif()
-

=== test/CMakeLists.txt ===
--- 
+++ 
@@ -14,6 +14,21 @@
         ${CMAKE_SOURCE_DIR}/src/lmo)
 
     add_test(NAME ${binary_name} COMMAND ${binary_name})
+
+    # Copy primecount.dll and primesieve.dll to test directory.
+    # On Windows the DLLs must be in the same directory as the
+    # binaries that depend on them.
+    if (WIN32 AND NOT STATICALLY_LINK_LIBPRIMECOUNT)
+        add_custom_command(TARGET ${binary_name} POST_BUILD
+            COMMAND ${CMAKE_COMMAND} -E copy_if_different
+                $<TARGET_FILE:libprimecount>
+                $<TARGET_FILE_DIR:${binary_name}>)
+
+        add_custom_command(TARGET ${binary_name} POST_BUILD
+            COMMAND ${CMAKE_COMMAND} -E copy_if_different
+                $<TARGET_FILE:libprimesieve>
+                $<TARGET_FILE_DIR:${binary_name}>)
+    endif()
 endforeach()
 
 # The order here is important, we want simpler implementations

=== test/api/CMakeLists.txt ===
--- 
+++ 
@@ -15,4 +15,19 @@
         ${CMAKE_SOURCE_DIR}/src/lmo)
 
     add_test(NAME ${binary_name} COMMAND ${binary_name})
+
+    # Copy primecount.dll and primesieve.dll to test directory.
+    # On Windows the DLLs must be in the same directory as the
+    # binaries that depend on them.
+    if (WIN32 AND NOT STATICALLY_LINK_LIBPRIMECOUNT)
+        add_custom_command(TARGET ${binary_name} POST_BUILD
+            COMMAND ${CMAKE_COMMAND} -E copy_if_different
+                $<TARGET_FILE:libprimecount>
+                $<TARGET_FILE_DIR:${binary_name}>)
+
+        add_custom_command(TARGET ${binary_name} POST_BUILD
+            COMMAND ${CMAKE_COMMAND} -E copy_if_different
+                $<TARGET_FILE:libprimesieve>
+                $<TARGET_FILE_DIR:${binary_name}>)
+    endif()
 endforeach()

=== test/deleglise-rivat/CMakeLists.txt ===
--- 
+++ 
@@ -14,4 +14,19 @@
         ${CMAKE_SOURCE_DIR}/src/lmo)
 
     add_test(NAME ${binary_name} COMMAND ${binary_name})
+
+    # Copy primecount.dll and primesieve.dll to test directory.
+    # On Windows the DLLs must be in the same directory as the
+    # binaries that depend on them.
+    if (WIN32 AND NOT STATICALLY_LINK_LIBPRIMECOUNT)
+        add_custom_command(TARGET ${binary_name} POST_BUILD
+            COMMAND ${CMAKE_COMMAND} -E copy_if_different
+                $<TARGET_FILE:libprimecount>
+                $<TARGET_FILE_DIR:${binary_name}>)
+
+        add_custom_command(TARGET ${binary_name} POST_BUILD
+            COMMAND ${CMAKE_COMMAND} -E copy_if_different
+                $<TARGET_FILE:libprimesieve>
+                $<TARGET_FILE_DIR:${binary_name}>)
+    endif()
 endforeach()

=== debian/changelog ===
primecount (7.20+ds-1) unstable; urgency=medium

  * New upstream minor release.
  * Debianization:
    - d/copyright:
      - Files-Excluded list, refresh;
      - debian/adhoc/lintian/privacy-breach/www/images/* entry, obsoleted;
    - d/patches/*:
      - d/p/debianization-documentation.patch, obsoleted;
    - d/adhoc/lintian/privacy-breach/*, obsoleted;
    - d/primecount-doc.links, refresh;
    - d/primecount-doc.docs, update;
    - d/control:
      - Rules-Requires-Root field, now rely on default.

 -- Jerome Benoit <calculus@rezozer.net>  Sun, 16 Nov 2025 19:32:04 +0000

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,6 @@
 Uploaders: Jerome Benoit <calculus@rezozer.net>
 Section: math
 Priority: optional
-Rules-Requires-Root: no
 Build-Depends:
  debhelper-compat (=13),
  cmake,

## primecount 8.0+ds

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,7 +1,7 @@
-cmake_minimum_required(VERSION 3.4...3.27)
+cmake_minimum_required(VERSION 3.9...3.30)
 project(primecount CXX)
-set(PRIMECOUNT_VERSION_MAJOR 7)
-set(PRIMECOUNT_VERSION_MINOR 20)
+set(PRIMECOUNT_VERSION_MAJOR 8)
+set(PRIMECOUNT_VERSION_MINOR 0)
 set(PRIMECOUNT_VERSION "${PRIMECOUNT_VERSION_MAJOR}.${PRIMECOUNT_VERSION_MINOR}")
 
 # Build options ######################################################
@@ -18,7 +18,14 @@
 option(WITH_DIV32           "Use 32-bit division instead of 64-bit division whenever possible" OFF)
 option(WITH_MSVC_CRT_STATIC "Link primecount.lib with /MT instead of the default /MD" OFF)
 option(WITH_FLOAT128        "Use __float128 (requires libquadmath), increases precision of Li(x) & RiemannR" OFF)
-option(WITH_JEMALLOC        "Use jemalloc allocator"               OFF)
+
+# Check if primecount is top level project ###########################
+
+if(CMAKE_CURRENT_SOURCE_DIR STREQUAL CMAKE_SOURCE_DIR)
+    set(PRIMECOUNT_IS_TOP_PROJECT ON)
+else()
+    set(PRIMECOUNT_IS_TOP_PROJECT OFF)
+endif()
 
 # Enable/Disable libdivide ###########################################
 
@@ -60,19 +67,29 @@
 
 # Set default build type to Release ##################################
 
-if(NOT CMAKE_VERSION VERSION_LESS 3.9)
+if(PRIMECOUNT_IS_TOP_PROJECT)
     get_property(isMultiConfig GLOBAL PROPERTY GENERATOR_IS_MULTI_CONFIG)
-elseif(CMAKE_CONFIGURATION_TYPES)
-    set(isMultiConfig TRUE)
-endif()
-
-if(NOT isMultiConfig AND NOT CMAKE_BUILD_TYPE)
-    set(CMAKE_BUILD_TYPE Release CACHE STRING
-    "Choose the type of build, options are: None Debug Release RelWithDebInfo MinSizeRel." FORCE)
+
+    if(NOT isMultiConfig AND NOT CMAKE_BUILD_TYPE)
+        message(STATUS "Setting CMAKE_BUILD_TYPE = Release")
+        set(CMAKE_BUILD_TYPE Release CACHE STRING
+            "Choose the type of build, options are: None Debug Release RelWithDebInfo MinSizeRel." FORCE)
+    endif()
 endif()
 
 if(CMAKE_BUILD_TYPE STREQUAL "Debug")
     list(APPEND PRIMECOUNT_COMPILE_DEFINITIONS "ENABLE_ASSERT")
+endif()
+
+# Hide symbols of inline functions ###################################
+# This reduces the size of the shared libprimecount by about 1%.
+
+if(PRIMECOUNT_IS_TOP_PROJECT)
+    if (NOT DEFINED CMAKE_VISIBILITY_INLINES_HIDDEN)
+        message(STATUS "Setting CMAKE_VISIBILITY_INLINES_HIDDEN = ON")
+        set(CMAKE_VISIBILITY_INLINES_HIDDEN ON CACHE BOOL
+            "Whether to add a compiler flag to hide symbols of inline functions")
+    endif ()
 endif()
 
 # primecount binary source files #####################################
@@ -115,11 +132,13 @@
             src/lmo/pi_lmo4.cpp
             src/lmo/pi_lmo5.cpp
             src/lmo/pi_lmo_parallel.cpp
+            src/deleglise-rivat/S2_easy.cpp
             src/deleglise-rivat/S2_hard.cpp
             src/deleglise-rivat/S2_trivial.cpp
             src/deleglise-rivat/pi_deleglise_rivat.cpp
             src/gourdon/pi_gourdon.cpp
             src/gourdon/Phi0.cpp
+            src/gourdon/AC.cpp
             src/gourdon/B.cpp
             src/gourdon/D.cpp
             src/gourdon/LoadBalancerAC.cpp
@@ -129,11 +148,7 @@
 # Use libdivide.h (fast integer divison) #############################
 
 if(WITH_LIBDIVIDE)
-    set(LIB_SRC ${LIB_SRC} src/deleglise-rivat/S2_easy_libdivide.cpp)
-    set(LIB_SRC ${LIB_SRC} src/gourdon/AC_libdivide.cpp)
-else()
-    set(LIB_SRC ${LIB_SRC} src/deleglise-rivat/S2_easy.cpp)
-    set(LIB_SRC ${LIB_SRC} src/gourdon/AC.cpp)
+    list(APPEND PRIMECOUNT_COMPILE_DEFINITIONS "ENABLE_LIBDIVIDE")
 endif()
 
 # Check if compiler supports CPU multiarch ###########################
@@ -144,16 +159,10 @@
 
     if(multiarch_x86_popcnt OR multiarch_avx512_vpopcnt)
         set(LIB_SRC ${LIB_SRC} src/arch/x86/cpuid.cpp)
-        if (multiarch_avx512_vpopcnt)
-            set(LIB_SRC ${LIB_SRC} src/deleglise-rivat/S2_hard_multiarch_avx512.cpp)
-            set(LIB_SRC ${LIB_SRC} src/gourdon/D_multiarch_avx512.cpp)
-        endif()
     else()
         include("${PROJECT_SOURCE_DIR}/cmake/multiarch_arm_sve.cmake")
         if(multiarch_arm_sve)
             set(LIB_SRC ${LIB_SRC} src/arch/arm/sve.cpp)
-            set(LIB_SRC ${LIB_SRC} src/deleglise-rivat/S2_hard_multiarch_arm_sve.cpp)
-            set(LIB_SRC ${LIB_SRC} src/gourdon/D_multiarch_arm_sve.cpp)
         endif()
     endif()
 endif()
@@ -307,9 +316,3 @@
 # will only work if the DLL is in the same directory or a directory
 # that is in the PATH environment variable.
 
-if(WIN32 AND TARGET libprimecount-static)
-    set(STATICALLY_LINK_LIBPRIMECOUNT ON)
-elseif(NOT TARGET libprimecount)
-    set(STATICALLY_LINK_LIBPRIMECOUNT ON)
-endif()
-

=== test/deleglise-rivat/CMakeLists.txt ===
--- 
+++ 
@@ -5,7 +5,7 @@
     add_executable(${binary_name} ${file})
     target_compile_definitions(${binary_name} PRIVATE ${PRIMECOUNT_COMPILE_DEFINITIONS})
     target_link_libraries(${binary_name} primecount::primecount primesieve::primesieve ${PRIMECOUNT_LINK_LIBRARIES})
- 
+
     target_include_directories(${binary_name}
     PRIVATE
         ${CMAKE_SOURCE_DIR}/src

=== debian/changelog ===
primecount (8.0+ds-1) unstable; urgency=medium

  * New upstream major release.
  * Debianization:
    - SONAME, bump from 7 to 8.

 -- Jerome Benoit <calculus@rezozer.net>  Fri, 26 Dec 2025 16:53:53 +0000

=== debian/control ===
--- 
+++ 
@@ -6,7 +6,7 @@
 Build-Depends:
  debhelper-compat (=13),
  cmake,
- libprimesieve-dev (>=8.0),
+ libprimesieve-dev,
  asciidoc-base, xmlto
 Build-Depends-Indep:
 	pandoc
@@ -28,7 +28,7 @@
  .
  This dummy package provides the standard installation.
 
-Package: libprimecount7
+Package: libprimecount8
 Architecture: any
 Multi-Arch: same
 Section: libs
@@ -51,7 +51,7 @@
 Multi-Arch: same
 Section: libdevel
 Depends:
- libprimecount7 (= ${binary:Version}), libprimecount-dev-common (= ${source:Version}),
+ libprimecount8 (= ${binary:Version}), libprimecount-dev-common (= ${source:Version}),
  libprimesieve-dev,
  ${misc:Depends}
 Suggests: primecount-doc (= ${source:Version}), pkgconf
@@ -70,8 +70,8 @@
 Package: libprimecount-dev-common
 Architecture: all
 Multi-Arch: foreign
-Replaces: libprimecount7-dev-common
-Breaks: libprimecount7-dev-common
+Replaces: libprimecount8-dev-common
+Breaks: libprimecount8-dev-common
 Section: libdevel
 Depends: ${misc:Depends}
 Recommends: libprimecount-dev (= ${binary:Version})

## primecount 8.1+ds

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,8 +1,8 @@
-cmake_minimum_required(VERSION 3.9...3.30)
-project(primecount CXX)
-set(PRIMECOUNT_VERSION_MAJOR 8)
-set(PRIMECOUNT_VERSION_MINOR 0)
-set(PRIMECOUNT_VERSION "${PRIMECOUNT_VERSION_MAJOR}.${PRIMECOUNT_VERSION_MINOR}")
+cmake_minimum_required(VERSION 3.9...4.2)
+
+project(primecount
+        VERSION 8.1
+        LANGUAGES CXX)
 
 # Build options ######################################################
 
@@ -248,8 +248,8 @@
 if(BUILD_SHARED_LIBS)
     add_library(libprimecount SHARED ${LIB_SRC})
     set_target_properties(libprimecount PROPERTIES OUTPUT_NAME primecount)
-    set_target_properties(libprimecount PROPERTIES SOVERSION ${PRIMECOUNT_VERSION_MAJOR})
-    set_target_properties(libprimecount PROPERTIES VERSION ${PRIMECOUNT_VERSION})
+    set_target_properties(libprimecount PROPERTIES SOVERSION ${PROJECT_VERSION_MAJOR})
+    set_target_properties(libprimecount PROPERTIES VERSION ${PROJECT_VERSION})
     target_compile_options(libprimecount PRIVATE "${WNO_UNINITIALIZED}")
     target_compile_definitions(libprimecount PRIVATE ${PRIMECOUNT_COMPILE_DEFINITIONS})
     target_link_libraries(libprimecount PRIVATE primesieve::primesieve ${PRIMECOUNT_LINK_LIBRARIES})
@@ -316,3 +316,6 @@
 # will only work if the DLL is in the same directory or a directory
 # that is in the PATH environment variable.
 
+if(WIN32 AND TARGET libprimecount-static)
+    set(STATICALLY_LINK_LIBPRIMECOUNT ON)
+elseif(NOT TARGET libprimecount)

=== debian/changelog ===
primecount (8.1+ds-1) unstable; urgency=medium

  * New upstream version.
  * Debianization:
    - d/{copyright,adhoc/{c,cpp}/Makefile, copyright year-tuples, refrech;
    - d/control:
      - Priority field, now rely on the default;
      - Standards-Version, bump to 4.7.3 (no change);
    - d/tests/*:
      - d/t/make-check-dev, refresh.

 -- Jerome Benoit <calculus@rezozer.net>  Sun, 01 Feb 2026 14:10:08 +0000

=== debian/control ===
--- 
+++ 
@@ -2,7 +2,6 @@
 Maintainer: Debian Math Team <team+math@tracker.debian.org>
 Uploaders: Jerome Benoit <calculus@rezozer.net>
 Section: math
-Priority: optional
 Build-Depends:
  debhelper-compat (=13),
  cmake,
@@ -10,7 +9,7 @@
  asciidoc-base, xmlto
 Build-Depends-Indep:
 	pandoc
-Standards-Version: 4.7.2
+Standards-Version: 4.7.3
 Vcs-Git: https://salsa.debian.org/math-team/primecount.git
 Vcs-Browser: https://salsa.debian.org/math-team/primecount
 Homepage: https://github.com/kimwalisch/primecount

=== debian/rules ===
--- 
+++ 
@@ -46,7 +46,7 @@
 override_dh_prep-arch: README.toc.md
 
 override_dh_installdocs:
-	dh_installdocs -pprimecount-bin    --link-doc=libprimecount7
+	dh_installdocs -pprimecount-bin    --link-doc=libprimecount8
 	dh_installdocs -plibprimecount-dev --doc-main-package=libprimecount-dev-common
 	dh_installdocs --remaining-packages

## primecount 8.2+ds

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,7 +1,7 @@
 cmake_minimum_required(VERSION 3.9...4.2)
 
 project(primecount
-        VERSION 8.1
+        VERSION 8.2
         LANGUAGES CXX)
 
 # Build options ######################################################

=== debian/changelog ===
primecount (8.2+ds-1) unstable; urgency=medium

  * New upstream version (Closes: #1128056).

 -- Jerome Benoit <calculus@rezozer.net>  Sun, 01 Mar 2026 18:22:06 +0000
